/***********************
  Force Choke Anyone
  v2.0
  by tk102
************************/

void RepeatingDamage(effect eDamage, int nSecondsRemaining, int nDamage, object oTarget, object oCaster);
void RecursiveChainLightning(object oSource, object oCaster, int nHitDice, int nCount, int nSpellID);
void DoArmbandChokeMagic(object oSelf);
void DoArmbandFlameMagic(object oSelf);
void DoArmbandLightningMagic(object oSelf);
object TK_Targeting(float fMaxDistance, location lPC);

void main() {
   object oArmband=GetItemPossessedBy(OBJECT_SELF,"tk_choke"); 
   int nMode=GetGlobalNumber("END_ROOM3_DEAD");

   if(GetIsObjectValid(GetWaypointByTag("K_EBON_HAWK_LOCATION")))
   { 
     ActionStartConversation(OBJECT_SELF,"tk_choke_invoke");
   }
   else
   {
     switch (nMode) {
       case 2:
              DoArmbandLightningMagic(OBJECT_SELF);
              break;
       case 1:
              DoArmbandFlameMagic(OBJECT_SELF);
              break;
       default:
              DoArmbandChokeMagic(OBJECT_SELF);
              break;
     }
   }
}

void DoArmbandLightningMagic(object oSelf) {
   int nDamage=15;
   int SWFP_HARMFUL = TRUE;
   int SWFP_PRIVATE_SAVE_TYPE = SAVING_THROW_WILL;
   int SWFP_DAMAGE = d6(nDamage);
   int SWFP_DAMAGE_TYPE = DAMAGE_TYPE_ELECTRICAL;
   int SWFP_DAMAGE_VFX = VFX_PRO_LIGHTNING_L; 
   effect eBump=EffectVisualEffect(SWFP_DAMAGE_VFX);
   location lPC=GetLocation(oSelf);
   object oTarget=TK_Targeting(17.0,lPC);
   ApplyEffectToObject(DURATION_TYPE_INSTANT, eBump, oTarget);
   ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(SWFP_DAMAGE, SWFP_DAMAGE_TYPE), oTarget);
   // Mark our first target
   SetLocalNumber(oTarget,5,1);
   // Unmark the target after 2 seconds
   DelayCommand(2.0,SetLocalNumber(oTarget,5,0));
   // chain reaction with diminishing effect
   DelayCommand(0.2,
                RecursiveChainLightning(
                    oTarget,
                    oSelf,
                    nDamage-1,
                    2,
                    GetSpellId()
                 )
                );
}


void DoArmbandFlameMagic(object oSelf) {
   effect eVFX2 = EffectVisualEffect(1039);  //flame impact
   effect eBump = EffectVisualEffect(2062);  //flame bumpout
   effect eHorror = EffectHorrified();
   effect eDamage = EffectDeath(TRUE,TRUE);
   location lPC=GetLocation(oSelf);
   object oClosest=TK_Targeting(17.0,lPC);
   if (!GetIsObjectValid(oClosest)) { return ; } 
   ApplyEffectToObject(DURATION_TYPE_INSTANT, eVFX2, oClosest);
   ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBump, oClosest, 1.5);
   ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eHorror, oClosest, 6.0);
   DelayCommand(1.5, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oClosest));
}



void DoArmbandChokeMagic(object oSelf) {
  effect eVFXChoke=EffectVisualEffect(VFX_IMP_CHOKE);
  effect eChoke=EffectChoke();
  eChoke=ExtraordinaryEffect(eChoke);

  int nDamage=GetHitDice(oSelf)*2/3;
  effect eDamage=EffectDamage(nDamage,DAMAGE_TYPE_BLUDGEONING);
  effect eAttrib_Link=EffectAbilityDecrease(ABILITY_CONSTITUTION,4);
  eAttrib_Link=EffectLinkEffects(eAttrib_Link, EffectAbilityDecrease(ABILITY_STRENGTH, 4));
  eAttrib_Link=EffectLinkEffects(eAttrib_Link, EffectAbilityDecrease(ABILITY_DEXTERITY, 4));
  location lPC=GetLocation(oSelf);
  object oPC=GetFirstPC();
  object oClosest=TK_Targeting(17.0,lPC);
  if (!GetIsObjectValid(oClosest)) { return ; } 

  // now determine if this target is already under the effect of choke
  int bIsChoking=FALSE;
  effect eCurrent=GetFirstEffect(oClosest);
  while (GetIsEffectValid(eCurrent)) {
    if ( (GetEffectSubType(eCurrent)==SUBTYPE_EXTRAORDINARY) ) {
      bIsChoking=TRUE;
      break;
    }
    eCurrent=GetNextEffect(oClosest); 
  }

  // if the target has been choking, then apply damage, 
  // otherwise start choking

  if (bIsChoking) {
    SendMessageToPC(oPC,GetTag(oClosest)+" is choking w/ damage");
    ApplyEffectToObject(DURATION_TYPE_INSTANT, eVFXChoke, oClosest);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eChoke, oClosest, 6.0);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eAttrib_Link, oClosest, 24.0);
    RepeatingDamage(eDamage, 7, nDamage, oClosest, oSelf);
  } 
  else {
    SendMessageToPC(oPC,GetTag(oClosest)+" is choking harmlessly");
    ApplyEffectToObject(DURATION_TYPE_INSTANT, eVFXChoke, oClosest);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eChoke, oClosest, 6.0); 
  }
}



void RepeatingDamage(effect eDamage, int nSecondsRemaining, int nDamage, object oTarget, object oCaster)
{
 if(GetIsObjectValid(oTarget))
 {
   if(!GetIsConversationActive() && !GetIsDead(oTarget) && !GetIsFriend(oTarget))
   {
     if(nSecondsRemaining % 2 == 0)
     {
       if (GetCurrentHitPoints(oTarget)<=nDamage) { // creature about to die...
          if (GetGoodEvilValue(oCaster)>25) {AdjustAlignment(oCaster,ALIGNMENT_DARK_SIDE,5);}
       }
       ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
     }
     --nSecondsRemaining;
     if(nSecondsRemaining > 0)
     {
       DelayCommand(1.0f, RepeatingDamage(eDamage, nSecondsRemaining, nDamage, oTarget, oCaster));
     }
     else 
     {
       if (GetGoodEvilValue(oCaster)>25) {AdjustAlignment(oCaster,ALIGNMENT_DARK_SIDE,5);}
     }       
   }

 }
}

void RecursiveChainLightning(object oSource, object oCaster, int nHitDice, int nCount, int nSpellID) {

 int SWFP_HARMFUL=TRUE;
 int SWFP_PRIVATE_SAVE_TYPE=SAVING_THROW_WILL;
 int SWFP_DAMAGE=d6(nHitDice);
 int SWFP_DAMAGE_TYPE = DAMAGE_TYPE_ELECTRICAL;
 int SWFP_DAMAGE_VFX = VFX_PRO_LIGHTNING_L; 
 // next zap will come from chest of previous recipient

 effect eLightning=EffectBeam(2066, oSource, BODY_NODE_CHEST);
 effect eBump=EffectVisualEffect(SWFP_DAMAGE_VFX);

 object oTheTarget;                     // this will be the new lightning recipient
 object oThisTarget;                    // potential recipient

 object oPC=GetFirstPC();
 object oPC2=GetPartyMemberByIndex(1);
 object oPC3=GetPartyMemberByIndex(2);

 float fMaxDistance=17.0;               // maximum distance from previous recipient
 float fClosestDistance=fMaxDistance;   // distance of closest recipient to previous
 float fThisDistance;                   // distance of this recipient to previous
 location lSource=GetLocation(oSource); // location of previous target

 // Let's find a new target
 oThisTarget=GetFirstObjectInShape(
   SHAPE_SPHERE,
   fMaxDistance,
   lSource,
   TRUE,
   OBJECT_TYPE_CREATURE
 );
 int nZapIndex;                         // when was this target zapped last?

 while (GetIsObjectValid(oThisTarget)) {
    if (
        (oThisTarget!=oPC) && 
        (oThisTarget!=oPC2) && 
        (oThisTarget!=oPC3) && 
        (oThisTarget != oSource) &&
        (!GetIsDead(oThisTarget))
       ) {
     nZapIndex=GetLocalNumber(oThisTarget,5);

     // make sure it has been at least 2 jumps since last time
     if ( (nZapIndex==0) || (nZapIndex+2<nCount) ) {   
       fThisDistance=GetDistanceBetween(oSource,oThisTarget);
       if (fThisDistance<fClosestDistance) {
         fClosestDistance=fThisDistance;
         oTheTarget=oThisTarget;
       }
     }
   }
   oThisTarget=GetNextObjectInShape (
     SHAPE_SPHERE,
     fMaxDistance,
     lSource,
     TRUE,
     OBJECT_TYPE_CREATURE
   );
 }
 
 if (!GetIsObjectValid(oTheTarget)) { return; }  // no one qualified for a zap so exit
 
 // ZAP!
 SignalEvent (oTheTarget,EventSpellCastAt(oCaster, nSpellID, TRUE));
 ApplyEffectToObject(DURATION_TYPE_INSTANT, eBump, oTheTarget);
 ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(SWFP_DAMAGE, SWFP_DAMAGE_TYPE), oTheTarget);
 ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLightning, oTheTarget, 1.0);
 SetLocalNumber(oTheTarget,5,nCount);          // mark it!
 DelayCommand(2.0,SetLocalNumber(oTheTarget,5,0));
 nCount++;   // next step
 nHitDice--; // diminish power
 if (nHitDice>0) {  
   DelayCommand(0.2,RecursiveChainLightning(oTheTarget, oCaster, nHitDice, nCount, nSpellID));  //recurse
 }
}

object TK_Targeting (float fMaxDistance, location lPC) {

  object oClosest;
  object oPC=GetFirstPC();
  object oPC2=GetPartyMemberByIndex(1);
  object oPC3=GetPartyMemberByIndex(2);

  float fClosestDistance=fMaxDistance;
  object oThisTarget;
  float fThisDistance;



  // first we look for the nearest living, non-party member
  oThisTarget=GetFirstObjectInShape(
              SHAPE_SPHERE, 
              fMaxDistance, 
              lPC,
              TRUE,
              OBJECT_TYPE_CREATURE
             );

  while (GetIsObjectValid(oThisTarget)) {
    if ((oThisTarget!=oPC) && 
        (oThisTarget!=oPC2) && 
        (oThisTarget!=oPC3) && 
        (!GetIsDead(oThisTarget))
       ) {
      fThisDistance=GetDistanceBetween(OBJECT_SELF,oThisTarget);
      if (fThisDistance<fClosestDistance) {
        fClosestDistance=fThisDistance;
        oClosest=oThisTarget;
      }
    }
    oThisTarget = GetNextObjectInShape(
        SHAPE_SPHERE,
        fMaxDistance,
        lPC,
        TRUE,
        OBJECT_TYPE_CREATURE
    );
  }
  return oClosest;
}
